﻿-- Daily Tamer Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dtcicon = "Interface\\ICONS\\INV_MISC_PETMOONKINTA"

local frame,btnclose -- dtc frame and its close button
local tab -- tamers table
local WEheader,WEtable -- world events table
--local worldeventschecked = false

       WEheader = EVENTS_LABEL
       WEtable = {}
       WEtable[CALENDAR_FILTER_DARKMOON] = { questID = 32175, name = "|TInterface\\icons\\INV_Misc_Eye_01:12|t "..CALENDAR_FILTER_DARKMOON.." (Jeremy Feasel)" }
       -- future world event tamers here
       tab = { [select(2,GetAchievementInfo(7936))] = {
                  [32434] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Fire:12|t "..GetAchievementCriteriaInfo(6974,5),
                  [32439] = "|TInterface\\icons\\Inv_pet_PandarenElemental:12|t "..GetAchievementCriteriaInfo(6974,6),
                  [32441] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Earth:12|t "..GetAchievementCriteriaInfo(6974,4),
                  [32440] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Air:12|t "..GetAchievementCriteriaInfo(6974,1)},
               [select(2,GetAchievementInfo(6606))] = {
                  [31957] = GetAchievementCriteriaInfo(6974,6).." (Shu)",
                  [31991] = GetAchievementCriteriaInfo(6974,5).." (Zusshi)",
                  [31956] = GetAchievementCriteriaInfo(6974,4).." (Yon)",
                  [31955] = GetAchievementCriteriaInfo(6974,2).." (Nishi)",
                  [31954] = GetAchievementCriteriaInfo(6974,3).." (Mo'ruk)",
                  [31953] = GetAchievementCriteriaInfo(6974,1).." (Hyuna)",
                  [31958] = GetAchievementCriteriaInfo(6974,7).." (Aki)"},
               [select(2,GetAchievementInfo(6607))] = {
                  [31935] = GetAchievementCriteriaInfo(45,9).." (Payne)",
                  [31926] = GetAchievementCriteriaInfo(44,7).." (Antari)",
                  [31916] = GetAchievementCriteriaInfo(42,22).." (Lydia)",
                  [31909] = GetAchievementCriteriaInfo(43,6).." (Trixxy)",
                  [31971] = GetAchievementCriteriaInfo(4868,4).." (Obalis)"} }

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local GREY        = "|cff999999"
local function AddColor(str,color)
 return color..str.."|r"
end

-- check for active world events
local function AddWorldEventTamers()
 local i
 local _,_,today = CalendarGetDate()
 for i = 1,CalendarGetNumDayEvents(0,today) do
  local title = CalendarGetDayEvent(0, today, i)
  table.foreach(WEtable,function(k,v)
   if title == k then
    if not tab[WEheader] then tab[WEheader] = {} end
    tab[WEheader][v.questID] = v.name
   end
  end)
 end
 --worldeventschecked = true
end

local function DrawTCheckFrame(obj)

 --if not worldeventschecked then
 AddWorldEventTamers()
 --end

 obj:ClearLines()
 obj:AddDoubleLine("Daily Tamer Check","|T"..dtcicon..":32|t")

  table.foreach(tab,function(k,v)
   obj:AddLine(" ")
   obj:AddLine(k)
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(COMPLETE,LIGHT_GREEN))
    else
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(INCOMPLETE ,LIGHT_RED))
    end
   end)
  end)
end

local function tamerquestcheck()

 if not frame then
  frame = CreateFrame("GameTooltip", "tchecktooltip", nil, "GameTooltipTemplate")
 end
  frame:SetOwner(UIParent)
  frame:SetFrameStrata("HIGH")  
  frame:EnableMouse(true)
  frame:SetToplevel(true)
  frame:SetMovable()
  frame:SetPadding(16)
  frame:SetScale(0.9)
  frame:RegisterForDrag("LeftButton")
  frame:SetScript("OnDragStart", function(self) 
			self:StartMoving( )
	 end)
  frame:SetScript("OnDragStop", function(self) 
 		self:StopMovingOrSizing()
 	end)
 DrawTCheckFrame(frame)
 frame:AddLine(" ")
 frame:AddLine(" ")
 
 if not btnclose then
  btnclose = CreateFrame("Button", "tcheckbutton", frame, "UIPanelButtonTemplate")
 end
 btnclose:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",-10,10)
 btnclose:SetWidth(150)
 btnclose:SetText("Close")
 btnclose:SetScript("OnClick", function(self)
  frame:Hide()
 end)
 btnclose:Show()
 frame:Show()
end

local DailyTamerCheck = ldb:NewDataObject("DailyTamerCheck", {
	type = "data source",
	icon = dtcicon,
	label = "Daily Tamer Check",
	OnClick = function(_,button)
         tamerquestcheck()
	end,
	OnTooltipShow = function(tooltip)
		 DrawTCheckFrame(tooltip)
	end,
})

local eventframe = CreateFrame("FRAME","DTCEventFrame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD");
local function eventhandler(self, event, ...)
 if event == "PLAYER_ENTERING_WORLD" then
  OpenCalendar()
  --eventframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
  --eventframe = nil
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_DAILYTAMERCHECK1 = "/dtcheck"
SLASH_DAILYTAMERCHECK2 = "/dtc"
SlashCmdList["DAILYTAMERCHECK"] = tamerquestcheck